--------------------------------------------------------------------
-- This is Glance.  One large array.
--------------------------------------------------------------------
Glance = {
	["Variables"]   = {},
	["Arrays"]	  = {["info"] = {}},
	["Functions"]   = {["Tooltip"] = {}},
	["Events"]	  = {},
	["Panels"]	  = {},
	["CheckBoxes"]  = {},
	["Scrollbars"]  = {},
	["Text"]		= {},
	["Frames"]	  = {},
	["Buttons"]	 = {},
	["Menus"]	   = {},
	["Data"]		= {},
	["Timers"]	  = {},
	["Commands"]	= {}
}

---------------------------
-- bypass wow time played
---------------------------
Glance.Functions.ChatFrame_DisplayTimePlayed = ChatFrame_DisplayTimePlayed

---------------------------
-- saved variables
---------------------------
Glance_Local = {
	["Options"] = {
		["Modules"] = {},
	},
}
Glance_Global = {}
Glance_Profile = {}
function Glance.Functions.loadDefaultVariables()
	if Glance_Local.Options.movePlayer == nil then Glance_Local.Options.movePlayer = true end
	if Glance_Local.Options.moveTarget == nil then Glance_Local.Options.moveTarget = true end
	if Glance_Local.Options.moveBuffs == nil then Glance_Local.Options.moveBuffs = true end
	if Glance_Local.Options.moveMinimap == nil then Glance_Local.Options.moveMinimap = true end
	if Glance_Local.Options.sendStats == nil then Glance_Local.Options.sendStats = true end
	if Glance_Local.Options.timePlayed == nil then Glance_Local.Options.timePlayed = true end
	if Glance_Local.Options.gameFont == nil then Glance_Local.Options.gameFont = false end
	if Glance_Local.Options.frameScale == nil then Glance_Local.Options.frameScale = 1 end
	if Glance_Local.button == nil then 
		Glance_Local.button = {
			["order"] = {
				["LEFT"] = {},
				["RIGHT"] = {},
			},
		}
	end
	if Glance_Global.Options == nil then
		Glance_Global.Options = {}
	end
	if Glance_Global.Options.frameColor == nil then 
		Glance_Global.Options.frameColor = {}
		Glance_Global.Options.frameColor[1] = {0,0,0,.5}
		Glance_Global.Options.frameColor[2] = {.4,0,0,.5}
		Glance_Global.Options.frameColor[3] = {.4, .4, .4, 1}
		Glance_Global.Options.frameColor[4] = {0,.5,.6,.5}
	end
	if Glance_Global.Options.frameColor[4] == nil then
		Glance_Global.Options.frameColor[4] = {0,0,.4,.5}
	end
end

---------------------------
-- Timers
---------------------------
Glance.Timers = {
	["load"] = {0,5,false,nil,"onLoad",nil},
	["flip"] = {0,1,true,nil,nil,"flip"},--min,max,reset,button,func,var
}

---------------------------
-- variables
---------------------------
Glance.Variables = {
	["flip"] = true,
	["vehicleCheck"] = false,
	["messageCheck"] = true,
	["button"] = {
		["order"] = {
			["LEFT"] = {},
			["RIGHT"] = {},
		},
	},
	["buttonX"] = 0,
	["Scrollbars"] = 0,
	["overflowFix"] = true,
	["Panels"] = 0,
	["loaded"] = false,
	["Debug"] = false,
	["timer1"] = 0,
	["timer5"] = 0,
	["Delay"] = true,
	["spacer"] = 12,
	["fnt_file"] = "Interface\\AddOns\\Glance\\fonts\\font.ttf",
	["screenWidth"] = GetScreenWidth() * UIParent:GetEffectiveScale(),
	["timePlayed"] = false,
	["hook"] = {
		["player"] = false,
		["target"] = false,
		["buffs"] = false,
		["minimap"] = false,
	},
	["gametime"] = {
		["total"] = 0,
		["level"] = 0,
		["session"] = 0,
		["initTotal"] = 0,
		["initLevel"] = 0,
		["initSession"] = 0,
	},
	["party"] = {
		["a"] = {
			["name"] = 0,
			["level"] = 0,
		},
		["b"] = {
			["name"] = 0,
			["level"] = 0,
		},
		["c"] = {
			["name"] = 0,
			["level"] = 0,
		},
		["d"] = {
			["name"] = 0,
			["level"] = 0,
		},
	},
	["defaultFrameColor"] = {
		[1] = {0,0,0,.5},
		[2] = {.4,0,0,.5},
		[3] = {.4, .4, .4, 1},
		[4] = {0,.5,.6,.5},
	},
	["swatch"] = {},
}



---------------------------
-- Arrays: scroll backDrop
---------------------------
Glance.Arrays.backDrop = {
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	tile = true,
	tileSize = 32,
	edgeSize = 8,
	insets = {
		left = 1,
		right = 1,
		top = 1,
		bottom = 1
	}
}


---------------------------
-- Arrays: colors
---------------------------
Glance.Arrays.colors = {
	["RGB"] = {
		["WHT"] = { 1, 1, 1 },
		["GRY"] = { .5, .5, .5 },
		["GRN"] = { .3, 1, .3 },
		["GLD"] = { .9, .7, .2 },
		["YEL"] = { 1, 1, 0 },
		["BLU"] = { 0, .4, 1 },
		["LBL"] = { .4, .8, .94 },
		["RED"] = { 1, 0, 0 },
		["PPL"] = { .6, 0, .8 },
	},
	["CLASS"] = {
		["HUNTER"] = "|cffABD473",
		["WARLOCK"] = "|cff9482C9",
		["PRIEST"] = "|cffFFFFFF",
		["PALADIN"] = "|cffF58CBA",
		["MAGE"] = "|cff69CCF0",
		["ROGUE"] = "|cffFFF569",
		["DRUID"] = "|cffFF7D0A",
		["SHAMAN"] = "|cff0070DE",
		["WARRIOR"] = "|cffC79C6E",
		["DEATH KNIGHT"] = "|cffC41F3B",
		["MONK"] = "|cff00FF96",
	},
	["HEX"] = {
		["white"] = "|cffffffff",
		["red"] = "|cffff0000",
		["blue"] = "|cff3636fc",
		["darkblue"] = "|cff6fb8f0",
		["lightblue"] = "|cff6ff0ee",
		["green"] = "|cff00ff00",
		["orange"] = "|cffff7700",
		["yellow"] = "|cfffff000",
		["gold"] = "|cffffd700",
		["purple"] = "|cff9B30FF",
		["gray"] = "|cffcfcfcf",
	},
	["FACTION"] = {
		["horde"] = "|cffC41F3B",
		["alliance"] = "|cff69CCF0",
	},
}