---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("Guild","LEFT")
local btn = gb.Guild
btn.text              = "Guild"
btn.enabled           = true
btn.events            = {"GUILD_ROSTER_UPDATE","PLAYER_GUILD_UPDATE"}
btn.update            = true
btn.tooltip           = true
btn.click             = true
btn.timer5            = true

---------------------------
-- update
---------------------------
function gf.Guild.update()
	local btn = gb.Guild
	if btn.enabled and gv.loaded then -- loaded keeps it from launching when defined
		Glance.Debug("function","update","Guild")
		local HEX = ga.colors.HEX
		local guild
		if IsInGuild() then
			local onlineTotal = 0
			GuildRoster()
			for i = 1, GetNumGuildMembers(true) do
				 local online = select(9, GetGuildRosterInfo(i))
				 if online then
					onlineTotal = onlineTotal + 1
				 end
			end
			guild = "Guild: "..HEX.green..onlineTotal
		else
			guild = "Guild: "..HEX.red.."0"
		end
		btn.button:SetText(guild)
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function gf.Guild.tooltip()
	Glance.Debug("function","tooltip","Guild")
	local btn = gb.Guild
	local tooltip = gf.Tooltip
	local HEX = ga.colors.CLASS
	if IsInGuild() then
		GuildRoster()
		local total = GetNumGuildMembers(true)
		local onlineTotal = 0
		local guild = {}
		for i = 1, total do
			local name,_, _,level,class,zone,_,_,online,_,_ = GetGuildRosterInfo(i)
			if online then
				onlineTotal = onlineTotal + 1
				table.insert(guild, {name, level, class, zone})
			end
		end
		tooltip.Title(onlineTotal.."/"..total.." Guild Member(s) Online", "GLD")
		table.sort(guild, function(a, b) return a[1] < b[1] end)
		for k, v in pairs(guild) do
			tooltip.Double(HEX[string.upper(v[3])]..v[1].." ("..v[2].." "..v[3]..")", v[4], "WHT", "WHT")
		end
		wipe(guild)
	else
		tooltip.Title("Guild Member(s)", "GLD")
		tooltip.Line("|rYou are not in a guild.", "WHT")
	end
	tooltip.Space()
	tooltip.Line("(Click to open the Guild tab.)","WHT")
end

---------------------------
-- click
---------------------------
function gf.Guild.click(self, button, down)
	Glance.Debug("function","click","Guild")
	if button == "LeftButton" then
		ToggleGuildFrame(1)
	end
end


---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("Guild")
end