---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("Location","RIGHT")
local btn = gb.Location
btn.text              = "Location"
btn.events            = {}
btn.enabled           = true
btn.update            = true
btn.click             = true
btn.timer1            = true

---------------------------
-- update
---------------------------
function gf.Location.update()
	local btn  = gb.Location
	if btn.enabled and gv.loaded then -- loaded keeps it from launching when defined
		if WorldMapFrame:IsVisible() == nil then
			local HEX = ga.colors.HEX
			local unitx, unity = GetPlayerMapPosition("player")
			local name, subName
			if IsInInstance() then
				name, subName = select(1, GetInstanceInfo()), select(4, GetInstanceInfo())
			else
				name, subName = GetZoneText(), GetSubZoneText()
			end
			if subName ~= "" then
				subName = " - "..subName
			end
			btn.button:SetFormattedText(HEX.darkblue.."%s"..HEX.lightblue.."%s ("..HEX.white.."%d, %d"..HEX.lightblue..")", name, subName, (unitx * 100), (unity * 100))
			btn.button:SetWidth(btn.button:GetTextWidth())
		end
	end
end

---------------------------
-- click
---------------------------
function gf.Location.click(self, button, down)
	Glance.Debug("function","click","Location")
	if (button == "LeftButton") then 
		ToggleFrame(WorldMapFrame)
	end
end

---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("Location")
end